; Tlcommande infrarouge, metteur,exemple d'application

; pour plus d'information consultez le site http://www.roboticus.org
; (c) http://www.roboticus.org
; rserv  une utilisation personnelle et dans un but non commercial et non
; lucratif.


; Tlcommande infrarouge, rcepteur
; 4 Sorties : Max 100W/sorties
; 4 Sorties analogique : 0-10V DC

	list   p=16f84a
	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_OFF & _XT_OSC


	#include <p16f84a.inc>
 	#include <define.inc>;

; variable equ 0x20 ;
	lamp equ 0x20;
	loop equ 0x21; 
	lum  equ 0x22
	compteur equ 0x23; pause
	boucle equ 0x24; boucle 8 bits
	cle equ 0x25; cle reue
	lum1 equ 0x26
	lum2 equ 0x27
	lum3 equ 0x28
	lum4 equ 0x29
	long equ 0x2a

; dbut du soft
	org 0;
	goto setup


setup 
	banksel TRISA
	movlw	0x00 ; toutes en sortie pour le moment
	movwf	TRISA
	movlw	H'01' ;	RB0/INT en entre les autres en sortie
	movwf	TRISB
	movlw	H'80
	movwf	OPTION_REG
	banksel PORTA
	clrf PORTA
	clrf PORTB
	movlw h'80'
	movwf long
	movlw h'fe'

	movwf lum2
 	movwf lum3
	movwf lum4
	movwf lum1;

	movlw lamp1;
	movwf lamp;
	movf  lum1, w
	movwf lum;
	call lightcontrol;
	movlw lamp2;
	movwf lamp;
	movf  lum2, w
	movwf lum;
	call lightcontrol;
	movlw lamp3;
	movwf lamp;
	movf  lum3, w
	movwf lum;
	call lightcontrol;
	movlw lamp4;
	movwf lamp;
	movf  lum4, w
	movwf lum;
	call lightcontrol;

	goto main;

main
	btfss PORTB, 0 
	goto rx
	goto main

rx 
	movlw h'08';
	movwf boucle; le compteur qui va faire la boucle pour qu'on reoive 8 bit
	call pause1280; on fait une pause de 1280 s le premier signal tant plus long comme a on est sur que c'est bien le premier signal vu qu'un signal pendant l'envoie sera de maximum 1280s, on met une pause un peu plus longue que 1280s et le premier signal du 1450s
	btfsc PORTB, 0; si le signal est dj repass a 0 c'est que c'est le mauvais, le vrai signal tant plus long que 1280s
    goto main; mauvais signal!!!

bouclerx 
	btfss PORTB, 0;
    goto bouclerx; attendre que le signal repasse a 0 ne pose pas de probleme, l'inverse si!
	call pause640; attend 640sec
	rlf cle, 1;
	btfss PORTB, 0; le signal est repass a 1 apres la pause de 640sec
	goto rx1;
	bcf cle,0;; le signal est toujours a 0;

rxend
	call pause820; comme a on est sur d'etre repasser a 1
	btfsc PORTB, 0; le signal doit tre a 1, sinon le signal est perdu
	goto main; signal incorrect!!!
	decfsz boucle, 1; boucle jusqu'a 8 bit reu
	goto bouclerx
	goto analyse; les 8 bits sont ru correctement, on va les analyser pour savoir ce qui faut faure

rx1
	bsf cle, 0; 1  t reu, on met le bit a l'tat haut
	goto rxend;


analyse:			; partie du code qui sera modifie par l'utilisateur!!!
	movlw h'11'
	subwf cle,w
	btfsc STATUS,Z
	goto seton1

	movlw h'01'
	subwf cle,w
	btfsc STATUS,Z
	goto setoff1

	movlw h'12'
	subwf cle,w
	btfsc STATUS,Z
	goto seton2

	movlw h'02'
	subwf cle,w
	btfsc STATUS,Z
	goto setoff2

	movlw h'13'
	subwf cle,w
	btfsc STATUS,Z
	goto seton3

	movlw h'03'
	subwf cle,w
	btfsc STATUS,Z
	goto setoff4

	movlw h'14'
	subwf cle,w
	btfsc STATUS,Z
	goto seton4

	movlw h'04'
	subwf cle,w
	btfsc STATUS,Z
	goto setoff4

	movlw h'20'
	subwf cle,w
	btfsc STATUS,Z
	goto setalloff

	movlw h'21'
	subwf cle,w
	btfsc STATUS,Z
	goto setallon

	movlw h'31'
	subwf cle,w
	btfsc STATUS,Z
	bsf PORTA, 1

	movlw h'32'
	subwf cle,w
	btfsc STATUS,Z
	bsf PORTA, 0

	movlw h'33'
	subwf cle,w
	btfsc STATUS,Z
	bsf PORTB, 5

	movlw h'34'
	subwf cle,w
	btfsc STATUS,Z
	bsf PORTB, 4

	movlw h'41'
	subwf cle,w
	btfsc STATUS,Z
	bcf PORTA, 1

	movlw h'42'
	subwf cle,w
	btfsc STATUS,Z
	bcf PORTA, 0

	movlw h'43'
	subwf cle,w
	btfsc STATUS,Z
	bcf PORTB, 5

	movlw h'44'
	subwf cle,w
	btfsc STATUS,Z
	bcf PORTB, 4

	goto main;

setalloff
	bcf PORTA, 0
	bcf PORTA, 1
	bcf PORTB, 4
	bcf PORTB, 5
	goto main
	
setallon
	bsf PORTA, 0
	bsf PORTA, 1
	bsf PORTB, 4
	bsf PORTB, 5
	goto main


seton1
	movlw h'80'
	movwf long
	bsf PORTA, 1
	incf lum1, f;
	movlw h'FF'
	subwf lum1,w
	btfsc STATUS,Z
	decf lum1, f;
	movlw lamp1;
	movwf lamp;
	movf  lum1, w
	movwf lum;
	call lightcontrol;
	goto main

setoff1
	decf lum1, f;
	movlw h'00';
	subwf lum1,w;
	btfsc STATUS, Z;
	goto setoff1stop
	goto setoff1end
setoff1stop
	incf lum1, f;
	decfsz long;
	goto setoff1end;
	bcf PORTA, 1
	movlw h'fe'
	movwf lum1;
setoff1end
	movlw lamp1;
	movwf lamp;
	movf  lum1, w
	movwf lum;
	call lightcontrol;
	goto main


seton2
	movlw h'80'
	movwf long
	bsf PORTA, 0
	incf lum2, f;
	movlw h'FF'
	subwf lum2,w
	btfsc STATUS,Z
	decf lum2, f;
	movlw lamp2;
	movwf lamp;
	movf  lum2, w
	movwf lum;
	call lightcontrol;
	goto main

setoff2
	decf lum2, f;
	movlw h'00';
	subwf lum2,w;
	btfsc STATUS, Z;
	goto setoff2stop
	goto setoff2end
setoff2stop
	incf lum2, f;
	decfsz long;
	goto setoff2end;
	bcf PORTA, 0
	movlw h'fe'
	movwf lum2;
setoff2end
	movlw lamp2;
	movwf lamp;
	movf  lum2, w
	movwf lum;
	call lightcontrol;
	goto main


seton3
	movlw h'80'
	movwf long
	bsf PORTB, 5
	incf lum3, f;
	movlw h'FF'
	subwf lum3,w
	btfsc STATUS,Z
	decf lum3, f;
	movlw lamp3;
	movwf lamp;
	movf  lum3, w
	movwf lum;
	call lightcontrol;
	goto main


setoff3
	decf lum3, f;
	movlw h'00';
	subwf lum3,w;
	btfsc STATUS, Z;
	goto setoff3stop
	goto setoff3end
setoff3stop
	incf lum3, f;
	decfsz long;
	goto setoff3end;
	bcf PORTB, 5
	movlw h'fe'
	movwf lum3;
setoff3end
	movlw lamp3;
	movwf lamp;
	movf  lum3, w
	movwf lum;
	call lightcontrol;
	goto main


seton4
	movlw h'80'
	movwf long
	bsf PORTB, 4
	incf lum4, f;
	movlw h'FF'
	subwf lum4,w
	btfsc STATUS,Z
	decf lum4, f;
	movlw lamp4;
	movwf lamp;
	movf  lum4, w
	movwf lum;
	call lightcontrol;
	goto main

setoff4
	decf lum4, f;
	movlw h'00';
	subwf lum4,w;
	btfsc STATUS, Z;
	goto setoff4stop
	goto setoff4end
setoff4stop
	incf lum4, f;
	decfsz long;
	goto setoff4end;
	bcf PORTB, 4
	movlw h'fe'
	movwf lum4;
setoff4end
	movlw lamp4;
	movwf lamp;
	movf  lum4, w
	movwf lum;
	call lightcontrol;
	goto main



lightcontrol ; Permet de controller la luminosit
			; 	movlw lamp* [1-4];
			; 	movwf lamp;
			; 	movlw luminosit  (Valeur au choix);
			; 	movwf lum;
	movf lum,W   ; a retir pour mode non invers
	sublw h'ff' ; " " " " " "
	movwf lum   ;"  "" " " "" " " 
	bsf PORTB, load;
	bcf PORTB, dat;
	bcf PORTB, clock
	btfsc lamp, 1;
	bsf PORTB, dat;
	bsf PORTB, clock;
	call wait
	bcf PORTB, clock;
	bcf PORTB, dat;
	btfsc lamp, 0;
	bsf PORTB, dat;
	bsf PORTB, clock;
	call wait
	bcf PORTB, clock
	bcf PORTB, dat;
	bsf PORTB, clock;
	call wait
	bcf PORTB, clock;
	movlw H'00'
	movwf loop;
beginlooplight;
	movlw h'08'	;
	subwf loop, 0;
	btfss STATUS, C	;
	goto inlooplight;
	bcf PORTB, load;
	call  wait
	bsf PORTB, load;
	return
inlooplight;
	btfsc lum, 7;
	bsf PORTB, dat;
    bsf PORTB, clock;
	call wait
	bcf PORTB, clock;
	bcf PORTB, dat;
	rlf lum, 1;
	incf loop, f;
	goto beginlooplight;

wait;
	nop
	nop
	nop
	nop
	return;	

pause1280		; pause de 1280sec et quelque poussiere pour tre sur...
	movlw h'FF';
	movwf compteur;
	call pause;
	movlw h'0A';
	movwf compteur;
	call pause;
	return

pause640 			; pause de 640 sec
	movlw h'80';
	movwf compteur;
	call pause;
	return

pause820 			; pause de 820 sec (milieu entre 640 et 1280)
	movlw h'A4';
	movwf compteur;
	call pause;
	return

pause 			; cre une pas de 5s
	nop
	nop
	decfsz compteur,F
	goto pause
	return


	end 
	
